# aws_secret – Manage secrets stored in AWS Secrets Manager

New in version 2.8.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Create, update, and delete secrets stored in AWS Secrets Manager.

## Requirements

The below requirements are needed on the host that executes this module.

- boto
- boto3
- botocore>=1.10.0
- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key

debug_botocore_endpoint_logs
boolean
added in 2.8

Choices:
- no ←
- yes

Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.

description - |  | Specifies a user-provided description of the secret.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
kms_key_id - |  | Specifies the ARN or alias of the AWS KMS customer master key (CMK) to be used to encrypt the `secret_string` or `secret_binary` values in the versions stored in this secret.
name - / required |  | Friendly name for the secret you are creating.
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
recovery_window - | Default: 30 | Only used if state is absent. Specifies the number of days that Secrets Manager waits before it can delete the secret. If set to 0, the deletion is forced without recovery.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
rotation_interval - | Default: 30 | Specifies the number of days between automatic scheduled rotations of the secret.
rotation_lambda - |  | Specifies the ARN of the Lambda function that can rotate the secret.
secret - | Default: "" | Specifies string or binary data that you want to encrypt and store in the new version of the secret.

secret_type
-

Choices:
- binary
- string ←

Specifies the type of data that you want to encrypt.

security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token

state
-

Choices:
- present ←
- absent

Whether the secret should be exist or not.

tags - |  | Specifies a list of user-defined tags that are attached to the secret.

validate_certs
boolean

Choices:
- no
- yes ←

When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: Add string to AWS Secrets Manager
      aws_secret:
        name: 'test_secret_string'
        state: present
        secret_type: 'string'
        secret: "{{ super_secret_string }}"

    - name: remove string from AWS Secrets Manager
      aws_secret:
        name: 'test_secret_string'
        state: absent
        secret_type: 'string'
        secret: "{{ super_secret_string }}"

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
secret complex | always | The secret information
| arn string | always | The ARN of the secret Sample: arn:aws:secretsmanager:eu-west-1:xxxxxxxxxx:secret:xxxxxxxxxxx
| last_accessed_date string | always | The date the secret was last accessed Sample: 2018-11-20T01:00:00+01:00
| last_changed_date string | always | The date the secret was last modified. Sample: 2018-11-20T12:16:38.433000+01:00
| name string | always | The secret name. Sample: my_secret
| rotation_enabled boolean | always | The secret rotation status.
| version_ids_to_stages dictionary | always | Provide the secret version ids and the associated secret stage. Sample: {'dc1ed59b-6d8e-4450-8b41-536dfe4600a9': ['AWSCURRENT']}

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- REY Remi (@rrey)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.